CKEDITOR.plugins.add( 'mtcollapsed',
{
  init: function( editor )
  {
    /* COMMAND */
    editor.addCommand( 'cmdMTCollapsedDialog', new CKEDITOR.dialogCommand( 'mtcollapsedDialog' ) );
    
    /* BUTTON */
    editor.ui.addButton( 'MTcollapsed',
    {
      label: 'Insert spoiler',
      command: 'cmdMTCollapsedDialog',
      icon: this.path + 'button.png'
    } );

    /* DIALOG */
    CKEDITOR.dialog.add( 'mtcollapsedDialog', function ( editor )
    {
      return {
        title : 'Spoiler settings',
        minWidth : 300,
        minHeight : 200,
        contents :
        [{
          id : 'tab1',
          label : 'Settings',
          elements :
          [{
            type : 'text',
            id : 'title',
            label : 'Spoiler title',
            onShow : function() { this.setValue('Hidden text'); },
            validate : CKEDITOR.dialog.validate.notEmpty( "Spoiler title should be provided" )
          }]
        }],
        onOk : function()
               {
                 var dialog = this;
                 var title = dialog.getValueOf( 'tab1', 'title' );

                 var openTag = '[collapsed title=' + title + ']';
                 var closeTag = '[/collapsed]';
                 var inplaceTag = ' ' + openTag + ' text ' + closeTag + ' ';

                 var S = editor.getSelection();
                 //console.log(S);

                 if( S == null)
                 {
                   editor.insertHtml(inplaceTag);
                   return;
                 }

                 var R = S.getRanges();
                 R = R[0];
      
                 if( R == null)
                 {
                   editor.insertHtml(inplaceTag);
                   return;
                 }


                 var startPos = Math.min(R.startOffset, R.endOffset);
                 var endPos = Math.max(R.startOffset, R.endOffset);
                  
                 //console.log(R);
                 if( startPos == endPos )
                 {
                   editor.insertHtml(inplaceTag);
                   return;
                 }

                 var container = new CKEDITOR.dom.element('p');
                 var fragment = R.extractContents();
                  
                 container.appendText(openTag);                  
                 fragment.appendTo(container);  
                 container.appendText(closeTag);

                 editor.insertElement(container);
               }
      };
    });//dialog.add
  }//init:
});//plugin.add
